-----------------------------------------------------------------------
--  Regtests.Audits.Model -- Regtests.Audits.Model
-----------------------------------------------------------------------
--  File generated by Dynamo DO NOT MODIFY
--  Template used: templates/model/package-body.xhtml
--  Ada Generator: https://github.com/stcarrez/dynamo Version 1.4.0
-----------------------------------------------------------------------
--  Copyright (C) 2022 Stephane Carrez
--  Written by Stephane Carrez (Stephane.Carrez@gmail.com)
--
--  Licensed under the Apache License, Version 2.0 (the "License");
--  you may not use this file except in compliance with the License.
--  You may obtain a copy of the License at
--
--      http://www.apache.org/licenses/LICENSE-2.0
--
--  Unless required by applicable law or agreed to in writing, software
--  distributed under the License is distributed on an "AS IS" BASIS,
--  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
--  See the License for the specific language governing permissions and
--  limitations under the License.
-----------------------------------------------------------------------
pragma Warnings (Off);
with Ada.Unchecked_Deallocation;
with Util.Beans.Objects.Time;
pragma Warnings (On);
package body Regtests.Audits.Model is

   pragma Style_Checks ("-mrIu");
   pragma Warnings (Off, "formal parameter * is not referenced");
   pragma Warnings (Off, "use clause for type *");
   pragma Warnings (Off, "use clause for private type *");

   use type ADO.Objects.Object_Record_Access;
   use type ADO.Objects.Object_Ref;

   function Audit_Key (Id : in ADO.Identifier) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => AUDIT_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Audit_Key;

   function Audit_Key (Id : in String) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => AUDIT_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Audit_Key;

   function "=" (Left, Right : Audit_Ref'Class) return Boolean is
   begin
      return ADO.Objects.Object_Ref'Class (Left) = ADO.Objects.Object_Ref'Class (Right);
   end "=";

   procedure Set_Field (Object : in out Audit_Ref'Class;
                        Impl   : out Audit_Access) is
      Result : ADO.Objects.Object_Record_Access;
   begin
      Object.Prepare_Modify (Result);
      Impl := Audit_Impl (Result.all)'Access;
   end Set_Field;

   --  Internal method to allocate the Object_Record instance
   overriding
   procedure Allocate (Object : in out Audit_Ref) is
      Impl : Audit_Access;
   begin
      Impl := new Audit_Impl;
      Impl.Entity_Id := ADO.NO_IDENTIFIER;
      Impl.Entity_Type := 0;
      Impl.Old_Value.Is_Null := True;
      Impl.New_Value.Is_Null := True;
      Impl.Date := ADO.DEFAULT_TIME;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Allocate;

   -- ----------------------------------------
   --  Data object: Audit
   -- ----------------------------------------

   procedure Set_Id (Object : in out Audit_Ref;
                     Value  : in ADO.Identifier) is
      Impl : Audit_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   function Get_Id (Object : in Audit_Ref)
                  return ADO.Identifier is
      Impl : constant Audit_Access
         := Audit_Impl (Object.Get_Object.all)'Access;
   begin
      return Impl.Get_Key_Value;
   end Get_Id;


   procedure Set_Entity_Id (Object : in out Audit_Ref;
                            Value  : in ADO.Identifier) is
      Impl : Audit_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Identifier (Impl.all, 2, Impl.Entity_Id, Value);
   end Set_Entity_Id;

   function Get_Entity_Id (Object : in Audit_Ref)
                  return ADO.Identifier is
      Impl : constant Audit_Access
         := Audit_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Entity_Id;
   end Get_Entity_Id;


   procedure Set_Entity_Type (Object : in out Audit_Ref;
                              Value  : in ADO.Entity_Type) is
      Impl : Audit_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Entity_Type (Impl.all, 3, Impl.Entity_Type, Value);
   end Set_Entity_Type;

   function Get_Entity_Type (Object : in Audit_Ref)
                  return ADO.Entity_Type is
      Impl : constant Audit_Access
         := Audit_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Entity_Type;
   end Get_Entity_Type;


   procedure Set_Old_Value (Object : in out Audit_Ref;
                             Value : in String) is
      Impl : Audit_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_String (Impl.all, 4, Impl.Old_Value, Value);
   end Set_Old_Value;

   procedure Set_Old_Value (Object : in out Audit_Ref;
                            Value  : in ADO.Nullable_String) is
      Impl : Audit_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_String (Impl.all, 4, Impl.Old_Value, Value);
   end Set_Old_Value;

   function Get_Old_Value (Object : in Audit_Ref)
                 return String is
      Value : constant ADO.Nullable_String := Object.Get_Old_Value;
   begin
      if Value.Is_Null then
         return "";
      else
         return Ada.Strings.Unbounded.To_String (Value.Value);
      end if;
   end Get_Old_Value;
   function Get_Old_Value (Object : in Audit_Ref)
                  return ADO.Nullable_String is
      Impl : constant Audit_Access
         := Audit_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Old_Value;
   end Get_Old_Value;


   procedure Set_New_Value (Object : in out Audit_Ref;
                             Value : in String) is
      Impl : Audit_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_String (Impl.all, 5, Impl.New_Value, Value);
   end Set_New_Value;

   procedure Set_New_Value (Object : in out Audit_Ref;
                            Value  : in ADO.Nullable_String) is
      Impl : Audit_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_String (Impl.all, 5, Impl.New_Value, Value);
   end Set_New_Value;

   function Get_New_Value (Object : in Audit_Ref)
                 return String is
      Value : constant ADO.Nullable_String := Object.Get_New_Value;
   begin
      if Value.Is_Null then
         return "";
      else
         return Ada.Strings.Unbounded.To_String (Value.Value);
      end if;
   end Get_New_Value;
   function Get_New_Value (Object : in Audit_Ref)
                  return ADO.Nullable_String is
      Impl : constant Audit_Access
         := Audit_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.New_Value;
   end Get_New_Value;


   procedure Set_Date (Object : in out Audit_Ref;
                       Value  : in Ada.Calendar.Time) is
      Impl : Audit_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Time (Impl.all, 6, Impl.Date, Value);
   end Set_Date;

   function Get_Date (Object : in Audit_Ref)
                  return Ada.Calendar.Time is
      Impl : constant Audit_Access
         := Audit_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Date;
   end Get_Date;

   --  Copy of the object.
   procedure Copy (Object : in Audit_Ref;
                   Into   : in out Audit_Ref) is
      Result : Audit_Ref;
   begin
      if not Object.Is_Null then
         declare
            Impl : constant Audit_Access
              := Audit_Impl (Object.Get_Load_Object.all)'Access;
            Copy : constant Audit_Access
              := new Audit_Impl;
         begin
            ADO.Objects.Set_Object (Result, Copy.all'Access);
            Copy.Copy (Impl.all);
            Copy.Entity_Id := Impl.Entity_Id;
            Copy.Entity_Type := Impl.Entity_Type;
            Copy.Old_Value := Impl.Old_Value;
            Copy.New_Value := Impl.New_Value;
            Copy.Date := Impl.Date;
         end;
      end if;
      Into := Result;
   end Copy;

   overriding
   procedure Find (Object  : in out Audit_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Impl  : constant Audit_Access := new Audit_Impl;
   begin
      Impl.Find (Session, Query, Found);
      if Found then
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      else
         ADO.Objects.Set_Object (Object, null);
         Destroy (Impl);
      end if;
   end Find;

   procedure Load (Object  : in out Audit_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier) is
      Impl  : constant Audit_Access := new Audit_Impl;
      Found : Boolean;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
         raise ADO.Objects.NOT_FOUND;
      end if;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Load;

   procedure Load (Object  : in out Audit_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier;
                   Found   : out Boolean) is
      Impl  : constant Audit_Access := new Audit_Impl;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
      else
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Audit_Ref;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl = null then
         Impl := new Audit_Impl;
         ADO.Objects.Set_Object (Object, Impl);
      end if;
      if not ADO.Objects.Is_Created (Impl.all) then
         Impl.Create (Session);
      else
         Impl.Save (Session);
      end if;
   end Save;

   overriding
   procedure Delete (Object  : in out Audit_Ref;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : constant ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl /= null then
         Impl.Delete (Session);
      end if;
   end Delete;

   --  --------------------
   --  Free the object
   --  --------------------
   overriding
   procedure Destroy (Object : access Audit_Impl) is
      type Audit_Impl_Ptr is access all Audit_Impl;
      procedure Unchecked_Free is new Ada.Unchecked_Deallocation
              (Audit_Impl, Audit_Impl_Ptr);
      pragma Warnings (Off, "*redundant conversion*");
      Ptr : Audit_Impl_Ptr := Audit_Impl (Object.all)'Access;
      pragma Warnings (On, "*redundant conversion*");
   begin
      Unchecked_Free (Ptr);
   end Destroy;

   overriding
   procedure Find (Object  : in out Audit_Impl;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Query, AUDIT_DEF'Access);
   begin
      Stmt.Execute;
      if Stmt.Has_Elements then
         Object.Load (Stmt, Session);
         Stmt.Next;
         Found := not Stmt.Has_Elements;
      else
         Found := False;
      end if;
   end Find;

   overriding
   procedure Load (Object  : in out Audit_Impl;
                   Session : in out ADO.Sessions.Session'Class) is
      Found : Boolean;
      Query : ADO.SQL.Query;
      Id    : constant ADO.Identifier := Object.Get_Key_Value;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Object.Find (Session, Query, Found);
      if not Found then
         raise ADO.Objects.NOT_FOUND;
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Audit_Impl;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Update_Statement
         := Session.Create_Statement (AUDIT_DEF'Access);
   begin
      if Object.Is_Modified (1) then
         Stmt.Save_Field (Name  => COL_0_1_NAME, --  id
                          Value => Object.Get_Key);
         Object.Clear_Modified (1);
      end if;
      if Object.Is_Modified (2) then
         Stmt.Save_Field (Name  => COL_1_1_NAME, --  entity_id
                          Value => Object.Entity_Id);
         Object.Clear_Modified (2);
      end if;
      if Object.Is_Modified (3) then
         Stmt.Save_Field (Name  => COL_2_1_NAME, --  entity_type
                          Value => Object.Entity_Type);
         Object.Clear_Modified (3);
      end if;
      if Object.Is_Modified (4) then
         Stmt.Save_Field (Name  => COL_3_1_NAME, --  old_value
                          Value => Object.Old_Value);
         Object.Clear_Modified (4);
      end if;
      if Object.Is_Modified (5) then
         Stmt.Save_Field (Name  => COL_4_1_NAME, --  new_value
                          Value => Object.New_Value);
         Object.Clear_Modified (5);
      end if;
      if Object.Is_Modified (6) then
         Stmt.Save_Field (Name  => COL_5_1_NAME, --  date
                          Value => Object.Date);
         Object.Clear_Modified (6);
      end if;
      if Stmt.Has_Save_Fields then
         Stmt.Set_Filter (Filter => "id = ?");
         Stmt.Add_Param (Value => Object.Get_Key);
         declare
            Result : Integer;
         begin
            Stmt.Execute (Result);
            if Result /= 1 then
               if Result /= 0 then
                  raise ADO.Objects.UPDATE_ERROR;
               end if;
            end if;
         end;
      end if;
   end Save;

   overriding
   procedure Create (Object  : in out Audit_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Query : ADO.Statements.Insert_Statement
                  := Session.Create_Statement (AUDIT_DEF'Access);
      Result : Integer;
   begin
      Session.Allocate (Id => Object);
      Query.Save_Field (Name  => COL_0_1_NAME, --  id
                        Value => Object.Get_Key);
      Query.Save_Field (Name  => COL_1_1_NAME, --  entity_id
                        Value => Object.Entity_Id);
      Query.Save_Field (Name  => COL_2_1_NAME, --  entity_type
                        Value => Object.Entity_Type);
      Query.Save_Field (Name  => COL_3_1_NAME, --  old_value
                        Value => Object.Old_Value);
      Query.Save_Field (Name  => COL_4_1_NAME, --  new_value
                        Value => Object.New_Value);
      Query.Save_Field (Name  => COL_5_1_NAME, --  date
                        Value => Object.Date);
      Query.Execute (Result);
      if Result /= 1 then
         raise ADO.Objects.INSERT_ERROR;
      end if;
      ADO.Objects.Set_Created (Object);
   end Create;

   overriding
   procedure Delete (Object  : in out Audit_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Delete_Statement
         := Session.Create_Statement (AUDIT_DEF'Access);
   begin
      Stmt.Set_Filter (Filter => "id = ?");
      Stmt.Add_Param (Value => Object.Get_Key);
      Stmt.Execute;
   end Delete;

   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Audit_Ref;
                       Name : in String) return Util.Beans.Objects.Object is
      Obj  : ADO.Objects.Object_Record_Access;
      Impl : access Audit_Impl;
   begin
      if From.Is_Null then
         return Util.Beans.Objects.Null_Object;
      end if;
      Obj := From.Get_Load_Object;
      Impl := Audit_Impl (Obj.all)'Access;
      if Name = "id" then
         return ADO.Objects.To_Object (Impl.Get_Key);
      elsif Name = "entity_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Entity_Id));
      elsif Name = "entity_type" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Entity_Type));
      elsif Name = "old_value" then
         if Impl.Old_Value.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.To_Object (Impl.Old_Value.Value);
         end if;
      elsif Name = "new_value" then
         if Impl.New_Value.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.To_Object (Impl.New_Value.Value);
         end if;
      elsif Name = "date" then
         return Util.Beans.Objects.Time.To_Object (Impl.Date);
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;


   procedure List (Object  : in out Audit_Vector;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class) is
      Stmt : ADO.Statements.Query_Statement
        := Session.Create_Statement (Query, AUDIT_DEF'Access);
   begin
      Stmt.Execute;
      Audit_Vectors.Clear (Object);
      while Stmt.Has_Elements loop
         declare
            Item : Audit_Ref;
            Impl : constant Audit_Access := new Audit_Impl;
         begin
            Impl.Load (Stmt, Session);
            ADO.Objects.Set_Object (Item, Impl.all'Access);
            Object.Append (Item);
         end;
         Stmt.Next;
      end loop;
   end List;

   --  ------------------------------
   --  Load the object from current iterator position
   --  ------------------------------
   procedure Load (Object  : in out Audit_Impl;
                   Stmt    : in out ADO.Statements.Query_Statement'Class;
                   Session : in out ADO.Sessions.Session'Class) is
      pragma Unreferenced (Session);
   begin
      Object.Set_Key_Value (Stmt.Get_Identifier (0));
      Object.Entity_Id := Stmt.Get_Identifier (1);
      Object.Entity_Type := ADO.Entity_Type (Stmt.Get_Integer (2));
      Object.Old_Value := Stmt.Get_Nullable_String (3);
      Object.New_Value := Stmt.Get_Nullable_String (4);
      Object.Date := Stmt.Get_Time (5);
      ADO.Objects.Set_Created (Object);
   end Load;
   function Email_Key (Id : in ADO.Identifier) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => EMAIL_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Email_Key;

   function Email_Key (Id : in String) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_INTEGER,
                                       Of_Class => EMAIL_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Email_Key;

   function "=" (Left, Right : Email_Ref'Class) return Boolean is
   begin
      return ADO.Objects.Object_Ref'Class (Left) = ADO.Objects.Object_Ref'Class (Right);
   end "=";

   procedure Set_Field (Object : in out Email_Ref'Class;
                        Impl   : out Email_Access) is
      Result : ADO.Objects.Object_Record_Access;
   begin
      Object.Prepare_Modify (Result);
      Impl := Email_Impl (Result.all)'Access;
   end Set_Field;

   --  Internal method to allocate the Object_Record instance
   overriding
   procedure Allocate (Object : in out Email_Ref) is
      Impl : Email_Access;
   begin
      Impl := new Email_Impl;
      Impl.Email.Is_Null := True;
      Impl.Status.Is_Null := True;
      Impl.Date.Is_Null := True;
      Impl.Create_Date := ADO.DEFAULT_TIME;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Allocate;

   -- ----------------------------------------
   --  Data object: Email
   -- ----------------------------------------

   procedure Set_Id (Object : in out Email_Ref;
                     Value  : in ADO.Identifier) is
      Impl : Email_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   function Get_Id (Object : in Email_Ref)
                  return ADO.Identifier is
      Impl : constant Email_Access
         := Email_Impl (Object.Get_Object.all)'Access;
   begin
      return Impl.Get_Key_Value;
   end Get_Id;


   procedure Set_Email (Object : in out Email_Ref;
                         Value : in String) is
      Impl : Email_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 2, Impl.Email, Value);
   end Set_Email;

   procedure Set_Email (Object : in out Email_Ref;
                        Value  : in ADO.Nullable_String) is
      Impl : Email_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 2, Impl.Email, Value);
   end Set_Email;

   function Get_Email (Object : in Email_Ref)
                 return String is
      Value : constant ADO.Nullable_String := Object.Get_Email;
   begin
      if Value.Is_Null then
         return "";
      else
         return Ada.Strings.Unbounded.To_String (Value.Value);
      end if;
   end Get_Email;
   function Get_Email (Object : in Email_Ref)
                  return ADO.Nullable_String is
      Impl : constant Email_Access
         := Email_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Email;
   end Get_Email;


   procedure Set_Status (Object : in out Email_Ref;
                         Value  : in ADO.Nullable_Integer) is
      Impl : Email_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Integer (Impl.all, 3, Impl.Status, Value);
   end Set_Status;

   function Get_Status (Object : in Email_Ref)
                  return ADO.Nullable_Integer is
      Impl : constant Email_Access
         := Email_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Status;
   end Get_Status;


   procedure Set_Date (Object : in out Email_Ref;
                       Value  : in ADO.Nullable_Time) is
      Impl : Email_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Time (Impl.all, 4, Impl.Date, Value);
   end Set_Date;

   function Get_Date (Object : in Email_Ref)
                  return ADO.Nullable_Time is
      Impl : constant Email_Access
         := Email_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Date;
   end Get_Date;


   procedure Set_Create_Date (Object : in out Email_Ref;
                              Value  : in Ada.Calendar.Time) is
      Impl : Email_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Time (Impl.all, 5, Impl.Create_Date, Value);
   end Set_Create_Date;

   function Get_Create_Date (Object : in Email_Ref)
                  return Ada.Calendar.Time is
      Impl : constant Email_Access
         := Email_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Create_Date;
   end Get_Create_Date;


   procedure Set_Info (Object : in out Email_Ref;
                        Value : in String) is
      Impl : Email_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_String (Impl.all, 6, Impl.Info, Value);
   end Set_Info;

   procedure Set_Info (Object : in out Email_Ref;
                       Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Email_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Unbounded_String (Impl.all, 6, Impl.Info, Value);
   end Set_Info;

   function Get_Info (Object : in Email_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Info);
   end Get_Info;
   function Get_Info (Object : in Email_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Email_Access
         := Email_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Info;
   end Get_Info;

   --  Copy of the object.
   procedure Copy (Object : in Email_Ref;
                   Into   : in out Email_Ref) is
      Result : Email_Ref;
   begin
      if not Object.Is_Null then
         declare
            Impl : constant Email_Access
              := Email_Impl (Object.Get_Load_Object.all)'Access;
            Copy : constant Email_Access
              := new Email_Impl;
         begin
            ADO.Objects.Set_Object (Result, Copy.all'Access);
            Copy.Copy (Impl.all);
            Copy.Email := Impl.Email;
            Copy.Status := Impl.Status;
            Copy.Date := Impl.Date;
            Copy.Create_Date := Impl.Create_Date;
            Copy.Info := Impl.Info;
         end;
      end if;
      Into := Result;
   end Copy;

   overriding
   procedure Find (Object  : in out Email_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Impl  : constant Email_Access := new Email_Impl;
   begin
      Impl.Find (Session, Query, Found);
      if Found then
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      else
         ADO.Objects.Set_Object (Object, null);
         Destroy (Impl);
      end if;
   end Find;

   procedure Load (Object  : in out Email_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier) is
      Impl  : constant Email_Access := new Email_Impl;
      Found : Boolean;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
         raise ADO.Objects.NOT_FOUND;
      end if;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Load;

   procedure Load (Object  : in out Email_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in ADO.Identifier;
                   Found   : out Boolean) is
      Impl  : constant Email_Access := new Email_Impl;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
      else
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Email_Ref;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl = null then
         Impl := new Email_Impl;
         ADO.Objects.Set_Object (Object, Impl);
      end if;
      if not ADO.Objects.Is_Created (Impl.all) then
         Impl.Create (Session);
      else
         Impl.Save (Session);
      end if;
   end Save;

   overriding
   procedure Delete (Object  : in out Email_Ref;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : constant ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl /= null then
         Impl.Delete (Session);
      end if;
   end Delete;

   --  --------------------
   --  Free the object
   --  --------------------
   overriding
   procedure Destroy (Object : access Email_Impl) is
      type Email_Impl_Ptr is access all Email_Impl;
      procedure Unchecked_Free is new Ada.Unchecked_Deallocation
              (Email_Impl, Email_Impl_Ptr);
      pragma Warnings (Off, "*redundant conversion*");
      Ptr : Email_Impl_Ptr := Email_Impl (Object.all)'Access;
      pragma Warnings (On, "*redundant conversion*");
   begin
      Unchecked_Free (Ptr);
   end Destroy;

   overriding
   procedure Find (Object  : in out Email_Impl;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Query, EMAIL_DEF'Access);
   begin
      Stmt.Execute;
      if Stmt.Has_Elements then
         Object.Load (Stmt, Session);
         Stmt.Next;
         Found := not Stmt.Has_Elements;
      else
         Found := False;
      end if;
   end Find;

   overriding
   procedure Load (Object  : in out Email_Impl;
                   Session : in out ADO.Sessions.Session'Class) is
      Found : Boolean;
      Query : ADO.SQL.Query;
      Id    : constant ADO.Identifier := Object.Get_Key_Value;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Object.Find (Session, Query, Found);
      if not Found then
         raise ADO.Objects.NOT_FOUND;
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Email_Impl;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Update_Statement
         := Session.Create_Statement (EMAIL_DEF'Access);
   begin
      if Object.Is_Modified (1) then
         Stmt.Save_Field (Name  => COL_0_2_NAME, --  id
                          Value => Object.Get_Key);
         Object.Clear_Modified (1);
      end if;
      if Object.Is_Modified (2) then
         Stmt.Save_Field (Name  => COL_1_2_NAME, --  user_email
                          Value => Object.Email);
         Object.Clear_Modified (2);
      end if;
      if Object.Is_Modified (3) then
         Stmt.Save_Field (Name  => COL_2_2_NAME, --  email_status
                          Value => Object.Status);
         Object.Clear_Modified (3);
      end if;
      if Object.Is_Modified (4) then
         Stmt.Save_Field (Name  => COL_3_2_NAME, --  email_date
                          Value => Object.Date);
         Object.Clear_Modified (4);
      end if;
      if Object.Is_Modified (5) then
         Stmt.Save_Field (Name  => COL_4_2_NAME, --  email_create_date
                          Value => Object.Create_Date);
         Object.Clear_Modified (5);
      end if;
      if Object.Is_Modified (6) then
         Stmt.Save_Field (Name  => COL_5_2_NAME, --  email_info
                          Value => Object.Info);
         Object.Clear_Modified (6);
      end if;
      if Stmt.Has_Save_Fields then
         Stmt.Set_Filter (Filter => "id = ?");
         Stmt.Add_Param (Value => Object.Get_Key);
         declare
            Result : Integer;
         begin
            Stmt.Execute (Result);
            if Result /= 1 then
               if Result /= 0 then
                  raise ADO.Objects.UPDATE_ERROR;
               end if;
            end if;
            ADO.Audits.Save (Object, Session);
         end;
      end if;
   end Save;

   overriding
   procedure Create (Object  : in out Email_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Query : ADO.Statements.Insert_Statement
                  := Session.Create_Statement (EMAIL_DEF'Access);
      Result : Integer;
   begin
      Session.Allocate (Id => Object);
      Query.Save_Field (Name  => COL_0_2_NAME, --  id
                        Value => Object.Get_Key);
      Query.Save_Field (Name  => COL_1_2_NAME, --  user_email
                        Value => Object.Email);
      Query.Save_Field (Name  => COL_2_2_NAME, --  email_status
                        Value => Object.Status);
      Query.Save_Field (Name  => COL_3_2_NAME, --  email_date
                        Value => Object.Date);
      Query.Save_Field (Name  => COL_4_2_NAME, --  email_create_date
                        Value => Object.Create_Date);
      Query.Save_Field (Name  => COL_5_2_NAME, --  email_info
                        Value => Object.Info);
      Query.Execute (Result);
      if Result /= 1 then
         raise ADO.Objects.INSERT_ERROR;
      end if;
      ADO.Objects.Set_Created (Object);
      ADO.Audits.Save (Object, Session);
   end Create;

   overriding
   procedure Delete (Object  : in out Email_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Delete_Statement
         := Session.Create_Statement (EMAIL_DEF'Access);
   begin
      Stmt.Set_Filter (Filter => "id = ?");
      Stmt.Add_Param (Value => Object.Get_Key);
      Stmt.Execute;
   end Delete;

   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Email_Ref;
                       Name : in String) return Util.Beans.Objects.Object is
      Obj  : ADO.Objects.Object_Record_Access;
      Impl : access Email_Impl;
   begin
      if From.Is_Null then
         return Util.Beans.Objects.Null_Object;
      end if;
      Obj := From.Get_Load_Object;
      Impl := Email_Impl (Obj.all)'Access;
      if Name = "id" then
         return ADO.Objects.To_Object (Impl.Get_Key);
      elsif Name = "email" then
         if Impl.Email.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.To_Object (Impl.Email.Value);
         end if;
      elsif Name = "status" then
         if Impl.Status.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Status.Value));
         end if;
      elsif Name = "date" then
         if Impl.Date.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.Time.To_Object (Impl.Date.Value);
         end if;
      elsif Name = "create_date" then
         return Util.Beans.Objects.Time.To_Object (Impl.Create_Date);
      elsif Name = "info" then
         return Util.Beans.Objects.To_Object (Impl.Info);
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;



   --  ------------------------------
   --  Load the object from current iterator position
   --  ------------------------------
   procedure Load (Object  : in out Email_Impl;
                   Stmt    : in out ADO.Statements.Query_Statement'Class;
                   Session : in out ADO.Sessions.Session'Class) is
      pragma Unreferenced (Session);
   begin
      Object.Set_Key_Value (Stmt.Get_Identifier (0));
      Object.Email := Stmt.Get_Nullable_String (1);
      Object.Status := Stmt.Get_Nullable_Integer (2);
      Object.Date := Stmt.Get_Nullable_Time (3);
      Object.Create_Date := Stmt.Get_Time (4);
      Object.Info := Stmt.Get_Unbounded_String (5);
      ADO.Objects.Set_Created (Object);
   end Load;
   function Property_Key (Id : in ADO.Identifier) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_STRING,
                                       Of_Class => PROPERTY_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Property_Key;

   function Property_Key (Id : in String) return ADO.Objects.Object_Key is
      Result : ADO.Objects.Object_Key (Of_Type  => ADO.Objects.KEY_STRING,
                                       Of_Class => PROPERTY_DEF'Access);
   begin
      ADO.Objects.Set_Value (Result, Id);
      return Result;
   end Property_Key;

   function "=" (Left, Right : Property_Ref'Class) return Boolean is
   begin
      return ADO.Objects.Object_Ref'Class (Left) = ADO.Objects.Object_Ref'Class (Right);
   end "=";

   procedure Set_Field (Object : in out Property_Ref'Class;
                        Impl   : out Property_Access) is
      Result : ADO.Objects.Object_Record_Access;
   begin
      Object.Prepare_Modify (Result);
      Impl := Property_Impl (Result.all)'Access;
   end Set_Field;

   --  Internal method to allocate the Object_Record instance
   overriding
   procedure Allocate (Object : in out Property_Ref) is
      Impl : Property_Access;
   begin
      Impl := new Property_Impl;
      Impl.Value.Is_Null := True;
      Impl.Float_Value := 0.0;
      Impl.Double_Value := 0.0;
      Impl.Kind := 0;
      Impl.Optional_Kind.Is_Null := True;
      Impl.Object_Id := ADO.NO_IDENTIFIER;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Allocate;

   -- ----------------------------------------
   --  Data object: Property
   -- ----------------------------------------

   procedure Set_Id (Object : in out Property_Ref;
                      Value : in String) is
      Impl : Property_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   procedure Set_Id (Object : in out Property_Ref;
                     Value  : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl : Property_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Objects.Set_Field_Key_Value (Impl.all, 1, Value);
   end Set_Id;

   function Get_Id (Object : in Property_Ref)
                 return String is
   begin
      return Ada.Strings.Unbounded.To_String (Object.Get_Id);
   end Get_Id;
   function Get_Id (Object : in Property_Ref)
                  return Ada.Strings.Unbounded.Unbounded_String is
      Impl : constant Property_Access
         := Property_Impl (Object.Get_Object.all)'Access;
   begin
      return Impl.Get_Key_Value;
   end Get_Id;


   procedure Set_Value (Object : in out Property_Ref;
                        Value  : in ADO.Nullable_Integer) is
      Impl : Property_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Integer (Impl.all, 2, Impl.Value, Value);
   end Set_Value;

   function Get_Value (Object : in Property_Ref)
                  return ADO.Nullable_Integer is
      Impl : constant Property_Access
         := Property_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Value;
   end Get_Value;


   procedure Set_Float_Value (Object : in out Property_Ref;
                              Value  : in Float) is
      Impl : Property_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Float (Impl.all, 3, Impl.Float_Value, Value);
   end Set_Float_Value;

   function Get_Float_Value (Object : in Property_Ref)
                  return Float is
      Impl : constant Property_Access
         := Property_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Float_Value;
   end Get_Float_Value;


   procedure Set_Double_Value (Object : in out Property_Ref;
                               Value  : in Long_Float) is
      Impl : Property_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Long_Float (Impl.all, 4, Impl.Double_Value, Value);
   end Set_Double_Value;

   function Get_Double_Value (Object : in Property_Ref)
                  return Long_Float is
      Impl : constant Property_Access
         := Property_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Double_Value;
   end Get_Double_Value;


   procedure Set_Kind (Object : in out Property_Ref;
                       Value  : in ADO.Entity_Type) is
      Impl : Property_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Entity_Type (Impl.all, 5, Impl.Kind, Value);
   end Set_Kind;

   function Get_Kind (Object : in Property_Ref)
                  return ADO.Entity_Type is
      Impl : constant Property_Access
         := Property_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Kind;
   end Get_Kind;


   procedure Set_Optional_Kind (Object : in out Property_Ref;
                                Value  : in ADO.Nullable_Entity_Type) is
      Impl : Property_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Entity_Type (Impl.all, 6, Impl.Optional_Kind, Value);
   end Set_Optional_Kind;

   function Get_Optional_Kind (Object : in Property_Ref)
                  return ADO.Nullable_Entity_Type is
      Impl : constant Property_Access
         := Property_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Optional_Kind;
   end Get_Optional_Kind;


   procedure Set_Object_Id (Object : in out Property_Ref;
                            Value  : in ADO.Identifier) is
      Impl : Property_Access;
   begin
      Set_Field (Object, Impl);
      ADO.Audits.Set_Field_Identifier (Impl.all, 7, Impl.Object_Id, Value);
   end Set_Object_Id;

   function Get_Object_Id (Object : in Property_Ref)
                  return ADO.Identifier is
      Impl : constant Property_Access
         := Property_Impl (Object.Get_Load_Object.all)'Access;
   begin
      return Impl.Object_Id;
   end Get_Object_Id;

   --  Copy of the object.
   procedure Copy (Object : in Property_Ref;
                   Into   : in out Property_Ref) is
      Result : Property_Ref;
   begin
      if not Object.Is_Null then
         declare
            Impl : constant Property_Access
              := Property_Impl (Object.Get_Load_Object.all)'Access;
            Copy : constant Property_Access
              := new Property_Impl;
         begin
            ADO.Objects.Set_Object (Result, Copy.all'Access);
            Copy.Copy (Impl.all);
            Copy.all.Set_Key (Impl.all.Get_Key);
            Copy.Value := Impl.Value;
            Copy.Float_Value := Impl.Float_Value;
            Copy.Double_Value := Impl.Double_Value;
            Copy.Kind := Impl.Kind;
            Copy.Optional_Kind := Impl.Optional_Kind;
            Copy.Object_Id := Impl.Object_Id;
         end;
      end if;
      Into := Result;
   end Copy;

   overriding
   procedure Find (Object  : in out Property_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Impl  : constant Property_Access := new Property_Impl;
   begin
      Impl.Find (Session, Query, Found);
      if Found then
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      else
         ADO.Objects.Set_Object (Object, null);
         Destroy (Impl);
      end if;
   end Find;

   procedure Load (Object  : in out Property_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in Ada.Strings.Unbounded.Unbounded_String) is
      Impl  : constant Property_Access := new Property_Impl;
      Found : Boolean;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
         raise ADO.Objects.NOT_FOUND;
      end if;
      ADO.Objects.Set_Object (Object, Impl.all'Access);
   end Load;

   procedure Load (Object  : in out Property_Ref;
                   Session : in out ADO.Sessions.Session'Class;
                   Id      : in Ada.Strings.Unbounded.Unbounded_String;
                   Found   : out Boolean) is
      Impl  : constant Property_Access := new Property_Impl;
      Query : ADO.SQL.Query;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Impl.Find (Session, Query, Found);
      if not Found then
         Destroy (Impl);
      else
         ADO.Objects.Set_Object (Object, Impl.all'Access);
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Property_Ref;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl = null then
         Impl := new Property_Impl;
         ADO.Objects.Set_Object (Object, Impl);
      end if;
      if not ADO.Objects.Is_Created (Impl.all) then
         Impl.Create (Session);
      else
         Impl.Save (Session);
      end if;
   end Save;

   overriding
   procedure Delete (Object  : in out Property_Ref;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Impl : constant ADO.Objects.Object_Record_Access := Object.Get_Object;
   begin
      if Impl /= null then
         Impl.Delete (Session);
      end if;
   end Delete;

   --  --------------------
   --  Free the object
   --  --------------------
   overriding
   procedure Destroy (Object : access Property_Impl) is
      type Property_Impl_Ptr is access all Property_Impl;
      procedure Unchecked_Free is new Ada.Unchecked_Deallocation
              (Property_Impl, Property_Impl_Ptr);
      pragma Warnings (Off, "*redundant conversion*");
      Ptr : Property_Impl_Ptr := Property_Impl (Object.all)'Access;
      pragma Warnings (On, "*redundant conversion*");
   begin
      Unchecked_Free (Ptr);
   end Destroy;

   overriding
   procedure Find (Object  : in out Property_Impl;
                   Session : in out ADO.Sessions.Session'Class;
                   Query   : in ADO.SQL.Query'Class;
                   Found   : out Boolean) is
      Stmt : ADO.Statements.Query_Statement
          := Session.Create_Statement (Query, PROPERTY_DEF'Access);
   begin
      Stmt.Execute;
      if Stmt.Has_Elements then
         Object.Load (Stmt, Session);
         Stmt.Next;
         Found := not Stmt.Has_Elements;
      else
         Found := False;
      end if;
   end Find;

   overriding
   procedure Load (Object  : in out Property_Impl;
                   Session : in out ADO.Sessions.Session'Class) is
      Found : Boolean;
      Query : ADO.SQL.Query;
      Id    : constant Ada.Strings.Unbounded.Unbounded_String := Object.Get_Key_Value;
   begin
      Query.Bind_Param (Position => 1, Value => Id);
      Query.Set_Filter ("id = ?");
      Object.Find (Session, Query, Found);
      if not Found then
         raise ADO.Objects.NOT_FOUND;
      end if;
   end Load;

   overriding
   procedure Save (Object  : in out Property_Impl;
                   Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Update_Statement
         := Session.Create_Statement (PROPERTY_DEF'Access);
   begin
      if Object.Is_Modified (1) then
         Stmt.Save_Field (Name  => COL_0_3_NAME, --  id
                          Value => Object.Get_Key);
         Object.Clear_Modified (1);
      end if;
      if Object.Is_Modified (2) then
         Stmt.Save_Field (Name  => COL_1_3_NAME, --  user_email
                          Value => Object.Value);
         Object.Clear_Modified (2);
      end if;
      if Object.Is_Modified (3) then
         Stmt.Save_Field (Name  => COL_2_3_NAME, --  float_value
                          Value => Object.Float_Value);
         Object.Clear_Modified (3);
      end if;
      if Object.Is_Modified (4) then
         Stmt.Save_Field (Name  => COL_3_3_NAME, --  double_value
                          Value => Object.Double_Value);
         Object.Clear_Modified (4);
      end if;
      if Object.Is_Modified (5) then
         Stmt.Save_Field (Name  => COL_4_3_NAME, --  kind
                          Value => Object.Kind);
         Object.Clear_Modified (5);
      end if;
      if Object.Is_Modified (6) then
         Stmt.Save_Field (Name  => COL_5_3_NAME, --  optional_kind
                          Value => Object.Optional_Kind);
         Object.Clear_Modified (6);
      end if;
      if Object.Is_Modified (7) then
         Stmt.Save_Field (Name  => COL_6_3_NAME, --  object_id
                          Value => Object.Object_Id);
         Object.Clear_Modified (7);
      end if;
      if Stmt.Has_Save_Fields then
         Stmt.Set_Filter (Filter => "id = ?");
         Stmt.Add_Param (Value => Object.Get_Key);
         declare
            Result : Integer;
         begin
            Stmt.Execute (Result);
            if Result /= 1 then
               if Result /= 0 then
                  raise ADO.Objects.UPDATE_ERROR;
               end if;
            end if;
            ADO.Audits.Save (Object, Session);
         end;
      end if;
   end Save;

   overriding
   procedure Create (Object  : in out Property_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Query : ADO.Statements.Insert_Statement
                  := Session.Create_Statement (PROPERTY_DEF'Access);
      Result : Integer;
   begin
      Query.Save_Field (Name  => COL_0_3_NAME, --  id
                        Value => Object.Get_Key);
      Query.Save_Field (Name  => COL_1_3_NAME, --  user_email
                        Value => Object.Value);
      Query.Save_Field (Name  => COL_2_3_NAME, --  float_value
                        Value => Object.Float_Value);
      Query.Save_Field (Name  => COL_3_3_NAME, --  double_value
                        Value => Object.Double_Value);
      Query.Save_Field (Name  => COL_4_3_NAME, --  kind
                        Value => Object.Kind);
      Query.Save_Field (Name  => COL_5_3_NAME, --  optional_kind
                        Value => Object.Optional_Kind);
      Query.Save_Field (Name  => COL_6_3_NAME, --  object_id
                        Value => Object.Object_Id);
      Query.Execute (Result);
      if Result /= 1 then
         raise ADO.Objects.INSERT_ERROR;
      end if;
      ADO.Objects.Set_Created (Object);
      ADO.Audits.Save (Object, Session);
   end Create;

   overriding
   procedure Delete (Object  : in out Property_Impl;
                     Session : in out ADO.Sessions.Master_Session'Class) is
      Stmt : ADO.Statements.Delete_Statement
         := Session.Create_Statement (PROPERTY_DEF'Access);
   begin
      Stmt.Set_Filter (Filter => "id = ?");
      Stmt.Add_Param (Value => Object.Get_Key);
      Stmt.Execute;
   end Delete;

   --  ------------------------------
   --  Get the bean attribute identified by the name.
   --  ------------------------------
   overriding
   function Get_Value (From : in Property_Ref;
                       Name : in String) return Util.Beans.Objects.Object is
      Obj  : ADO.Objects.Object_Record_Access;
      Impl : access Property_Impl;
   begin
      if From.Is_Null then
         return Util.Beans.Objects.Null_Object;
      end if;
      Obj := From.Get_Load_Object;
      Impl := Property_Impl (Obj.all)'Access;
      if Name = "id" then
         return ADO.Objects.To_Object (Impl.Get_Key);
      elsif Name = "value" then
         if Impl.Value.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Value.Value));
         end if;
      elsif Name = "float_value" then
         return Util.Beans.Objects.To_Object (Impl.Float_Value);
      elsif Name = "double_value" then
         return Util.Beans.Objects.To_Object (Impl.Double_Value);
      elsif Name = "kind" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Kind));
      elsif Name = "optional_kind" then
         if Impl.Optional_Kind.Is_Null then
            return Util.Beans.Objects.Null_Object;
         else
            return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Optional_Kind.Value));
         end if;
      elsif Name = "object_id" then
         return Util.Beans.Objects.To_Object (Long_Long_Integer (Impl.Object_Id));
      end if;
      return Util.Beans.Objects.Null_Object;
   end Get_Value;



   --  ------------------------------
   --  Load the object from current iterator position
   --  ------------------------------
   procedure Load (Object  : in out Property_Impl;
                   Stmt    : in out ADO.Statements.Query_Statement'Class;
                   Session : in out ADO.Sessions.Session'Class) is
      pragma Unreferenced (Session);
   begin
      Object.Set_Key_Value (Stmt.Get_Unbounded_String (0));
      Object.Value := Stmt.Get_Nullable_Integer (1);
      Object.Float_Value := Stmt.Get_Float (2);
      Object.Double_Value := Stmt.Get_Long_Float (3);
      Object.Kind := ADO.Entity_Type (Stmt.Get_Integer (4));
      Object.Optional_Kind := Stmt.Get_Nullable_Entity_Type (5);
      Object.Object_Id := Stmt.Get_Identifier (6);
      ADO.Objects.Set_Created (Object);
   end Load;


end Regtests.Audits.Model;
